#!/usr/bin/env python2.3
# -*- coding: utf-8 -*-
#
from mod_python import apache
import teng


# default handler
def index(req):
    req.content_type = "text/html"
    
    html = """<html><head><title>Teng demo app</title></head>
<body>
<h1>Teng demo aplikace</h1>

Priklady jsou dostupne pod ruznymi metodami, napr:
<ul>
<li><a href="/index.py/pokus2">pokus2</a></li>
<li><a href="/index.py/pokus3">pokus3</a></li>
<li><a href="/index.py/pokus3?templ=pokus3-2.html">pokus3-2</a></li>
<li><a href="/index.py/pokus3?templ=pokus3-2.html&amp;lang=de">pokus3-2 s 'de' slovnikem</a></li>
<li>atd...</li>
</ul>

</body>
</hmtl>
"""
    return html
    
    
def pokus1(req):
    req.content_type = "text/html"

    html = "<h1> blaf</h1>\naaa bbb\n"
    return html



def pokus2(req):
    req.content_type = "text/html"

    # vygeneruj stranku
    res = t.generatePage(
        templateFilename = "pokus2.html",
        data = {"content": "Hello World!"} )

    # vrat vysledek
    html = res["output"]
    return html



def pokus3(req):
    req.content_type = "text/html"

    # zjisti parametery z url
    templ = req.form.get('templ', default = "pokus3.html")
    lang = req.form.get('lang', default = "")
    free = req.form.get('free', default = 34859854)
    msg =  req.form.get('msg', default = 1)
   
    # vygenerovat stranku
    res = t.generatePage(
        templateFilename = templ, #sablona
        dictionaryFilename = "pokus3.dict", #jazykovy slovnik
        configFilename = "pokus3.conf", #config (alias nejazykovy slovnik]
	language = lang,
        data = {"userName": "johnny",
                "freeSpace": free,
		"msgCount": msg} )

    # vrat vysledek
    html = res["output"]
    return html



def pokus4(req):
    req.content_type = "text/html"

    # zjisti parametery z url
    templ = req.form.get('templ', default = "pokus4.html")

    # data root pro teng
    d = {}
    
    # zaloz multifragment 'ff'
    d["ff"] = []
    # pridej 3 iterace
    d["ff"].append( {"text":"prvni", "cislo":10} )
    d["ff"].append( {"text":"druhy", "cislo":200} )
    d["ff"].append( {"text":"treti", "cislo":333} )
    
    # 4. iterace multifragmentu 'ff' obsahuje vnoreny fragment 'cisla'
    # priprav obsah vnoreneho multifragmentu
    ff4 = []
    ff4.append( {"cislo":42} )
    ff4.append( {"cislo":44} )
    ff4.append( {"cislo":456} )
    
    # pridej 4. iteraci do fragmentu 'ff'
    d["ff"].append( {"text":"ctvrty", "cisla": ff4} )
    
    
    d["uzivatel"] = "john.doe"
    d["address"] = "<johnny@seznam.cz>"
    
    # vygenerovat stranku
    res = t.generatePage(
        templateFilename = templ, #sablona
        configFilename = "pokus3.conf", #config
        data = d)

    html = res["output"]
    return html




# default handler
#index = pokus1


### inicializace tengu

# create Teng object - simple
t = teng.Teng("/root/cvs/web/templ", #root path
    	"utf-8", #default encoding
	"text/html") #default content-type (for escaping)





'''
>>> print teng.Teng.__doc__
Create new teng engine
arguments:
    root                      Root path for relative paths
    encoding                  Default encoding for generatePage()
    contentType               Defautl contentType for generatePage()
    templateCacheSize         Specifies maximal number of templates in the
                              cache.
    dictionaryCacheSize       Specifies maximal number of dictionaries
                              in the cache.





>>> print t.generatePage.__doc__
Generate page from template, dictionaries and data.

arguments:
1. source is:
    string templateFilename   Path to template.
    string skin               Skin -- appended after last dot of filename.
                              (..../x.html + std -> ..../x.std.html)
                              Accepted only together with templateFilename.
   or:
    string templateString     Template.

2. output is
    string outputFilename     Path to output file.
   or:
    string outputFile         File object (must be open for writing)
                              or file-like object (must have write() method
   or:
    Returned as item in result structure (see below)

3. dictionaries are:
    string dictionaryFilename File with language dictionary.
    string language           Language variation.
                              Appended after last dot of filename.
                              (..../x.dict en -> ..../x.en.dict)
    string configFilename     File with configuration.

4. and other arguments are:
    string contentType        Content-type of template.
                              Use teng.listSupportedContentTypes()
                              for accepted values
    string encoding           Encoding of data. Used for conversion
                              od Unicode object to 8bit strings.

5. Data are:
    dict, list or Fragment data  Hierarchical data (see documentation).

Or above measn exclusive or! 'templateFilename' and 'templateString'
cannot be specified together. Arguments'outputFilename' and 'outputFile'
collide too. When no output specified result will be stored in
result structure.

Result:
    dict {
        string output         Result of page generation when no output
                              specified
        int status            Indicates error/no error during generation.
        tuple errorLog        error log
    }


    res = t.generatePage(
        templateFilename = "pokus3.html",
        #skin = req.config.template.skin,
        dictionaryFilename = "pokus3.dict",
        #language = lang,
        configFilename = "pokus3.conf",
        data = {},
        #outputFile = req,
        #contentType = "text/html"
	)
'''
